#![allow(deprecated)]
use std::fmt;
use std::str;
/// The align to value for an event offset. If the queried event is a moment, the offset will be the moment timestamp regardless of the align to value.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum EventAlignTo {
    #[serde(rename = "START")]
    Start,
    #[serde(rename = "END")]
    End,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl EventAlignTo {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            EventAlignTo::Start => "START",
            EventAlignTo::End => "END",
            EventAlignTo::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for EventAlignTo {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for EventAlignTo {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for EventAlignTo {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<EventAlignTo, conjure_object::plain::ParseEnumError> {
        match v {
            "START" => Ok(EventAlignTo::Start),
            "END" => Ok(EventAlignTo::End),
            v => v.parse().map(|v| EventAlignTo::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for EventAlignTo {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<EventAlignTo, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the EventAlignTo enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
